export { TextInput, TextInputMask } from '@versini/ui-textinput';
export { Toggle } from '@versini/ui-toggle';
import * as _versini_ui_private_dist_utilities from '@versini/ui-private/dist/utilities';
import React from 'react';

declare const TextArea: React.ForwardRefExoticComponent<{
    label: string;
    name: string;
    error?: boolean;
    focusMode?: "dark" | "light" | "system" | "alt-system";
    helperText?: string;
    helperTextOnFocus?: boolean;
    labelId?: string;
    mode?: "dark" | "light" | "system" | "alt-system";
    noBorder?: boolean;
    raw?: boolean;
    rightElement?: React.ReactElement;
    textAreaClassName?: string;
} & _versini_ui_private_dist_utilities.SpacingProps & React.TextareaHTMLAttributes<HTMLTextAreaElement> & React.RefAttributes<HTMLTextAreaElement>>;

export { TextArea };
