import { jsxs as S, jsx as d, Fragment as J } from "react/jsx-runtime";
import a from "clsx";
import { TextArea as Se } from "./components/TextArea/TextArea.js";
import B, { useState as M, useLayoutEffect as K, useRef as k, useMemo as H, useEffect as $, useId as X, useReducer as Q, useCallback as W } from "react";
/*!
  @versini/ui-form v1.5.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_FORM__ || (window.__VERSINI_UI_FORM__ = {
    version: "1.5.0",
    buildTime: "09/18/2024 11:18 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const V = "av-text-input", Y = "av-text-input-wrapper", D = "av-text-input-helper-text";
function Z() {
  const e = k(!1);
  return $(() => (e.current = !0, () => {
    e.current = !1;
  }), []), W(() => e.current, []);
}
const ee = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function re(e) {
  const t = Z(), r = k(0), n = k(null), [o, c] = M(ee), l = H(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((s) => {
    const i = s[0];
    i && (cancelAnimationFrame(r.current), r.current = requestAnimationFrame(() => {
      n.current && t() && c(i.contentRect);
    }));
  }), [t]);
  return $(() => (n.current && (l == null || l.observe(n.current, e)), () => {
    l == null || l.disconnect(), r.current && cancelAnimationFrame(r.current);
  }), [l, e]), [n, o];
}
function te(e) {
  const t = X();
  if (!e)
    return t;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${t}`;
  if (typeof e == "object") {
    const { id: r, prefix: n = "" } = e;
    return typeof r == "number" || typeof r == "string" ? `${n}${r}` : `${n}${t}`;
  }
}
const L = "SET_ANNOUNCEMENT", O = "CLEAR_ANNOUNCEMENT", ne = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, oe = (e, t) => {
  switch (t == null ? void 0 : t.type) {
    case L:
      return {
        ...e,
        announcement: t.payload
      };
    case O:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, ae = ({
  onAnnouncementClear: e,
  dispatch: t
}) => {
  t({
    type: O
  }), typeof e == "function" && e();
}, F = ({
  children: e,
  clearAnnouncementDelay: t,
  clearAnnouncementTimeoutRef: r,
  onAnnouncementClear: n,
  dispatch: o
}) => {
  (r == null ? void 0 : r.current) !== null && clearTimeout(r.current), e !== null && o({
    type: L,
    payload: e
  }), t && (r.current = setTimeout(
    () => ae({
      onAnnouncementClear: n,
      dispatch: o
    }),
    t
  ));
}, le = ({
  children: e,
  announcementTimeoutRef: t,
  announcementDelay: r,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: c,
  dispatch: l
}) => {
  clearTimeout(t.current), r ? t.current = setTimeout(F, r, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: c,
    dispatch: l
  }) : F({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: c,
    dispatch: l
  });
};
function j({
  children: e,
  className: t,
  politeness: r,
  role: n = null,
  announcementDelay: o,
  clearAnnouncementDelay: c,
  onAnnouncementClear: l,
  visible: s,
  ...i
}) {
  const u = k(), h = k(), [b, g] = Q(oe, {
    announcement: null
  });
  let m = r;
  typeof m > "u" && (m = n ? ne[n] : "assertive"), $(() => {
    le({
      announcementTimeoutRef: u,
      announcementDelay: o,
      children: e,
      clearAnnouncementDelay: c,
      clearAnnouncementTimeoutRef: h,
      onAnnouncementClear: l,
      dispatch: g
    });
  }, [
    e,
    o,
    c,
    l
  ]);
  const p = a(t, {
    "sr-only": !s
  });
  return /* @__PURE__ */ d(
    "div",
    {
      "aria-live": m,
      ...n && { role: n },
      className: p,
      ...i,
      children: b.announcement
    }
  );
}
const ce = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
};
/*!
  @versini/ui-private v1.4.10
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.10",
    buildTime: "09/18/2024 11:17 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const se = ({
  mode: e
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), ie = ({
  focusMode: e
}) => a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), ue = ({
  noBorder: e,
  error: t
}) => a("border-2", {
  "border-border-dark": !e && !t,
  "focus:border-border-dark": !e && t,
  "border-border-error-dark": !e && t,
  "border-transparent": e
}), de = ({
  disabled: e,
  raw: t,
  error: r,
  mode: n
}) => {
  if (t)
    return "";
  if (e)
    return a("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!r)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-lighter": n === "system",
      "text-copy-lighter dark:text-copy-dark": n === "alt-system"
    });
  if (r)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": n === "system",
      "text-copy-lighter dark:text-copy-error-dark": n === "alt-system"
    });
}, me = ({
  error: e,
  raw: t,
  mode: r,
  disabled: n
}) => {
  if (t)
    return "";
  if (n)
    return a(
      D,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return a(D, "absolute px-2 font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return a(D, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": r === "alt-system"
    });
}, pe = ({
  className: e,
  inputClassName: t,
  raw: r,
  disabled: n,
  noBorder: o,
  error: c,
  spacing: l,
  mode: s,
  focusMode: i
}) => {
  const u = r ? e : a(
    "relative flex w-full flex-col justify-center",
    Y,
    e,
    ce(l)
  ), h = r ? a(t) : a(
    V,
    t,
    "h-12 rounded-md px-4 text-base",
    se({ mode: s }),
    ie({ focusMode: i }),
    ue({ noBorder: o, error: c }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": n
    }
  ), b = r ? void 0 : "sr-only", g = de({
    disabled: n,
    raw: r,
    error: c,
    mode: s
  }), m = me({
    error: c,
    raw: r,
    mode: s,
    disabled: n
  });
  return {
    wrapper: u,
    input: h,
    accessibleLabel: b,
    visibleLabel: g,
    helperText: m,
    rightElement: r ? void 0 : "absolute right-3"
  };
}, G = B.forwardRef(
  ({
    id: e,
    name: t,
    label: r,
    error: n = !1,
    raw: o = !1,
    className: c,
    inputClassName: l,
    mode: s = "system",
    focusMode: i = "system",
    disabled: u = !1,
    noBorder: h = !1,
    labelId: b,
    labelHidden: g = !1,
    type: m = "text",
    helperText: p = "",
    rightElement: x,
    spacing: A,
    ...T
  }, N) => {
    const [E, w] = re(), [C, I] = M(0), v = te({ id: e, prefix: `${V}-` }), R = `${t} error, ${p}`, y = pe({
      className: c,
      inputClassName: l,
      error: n,
      raw: o,
      focusMode: i,
      disabled: u,
      noBorder: h,
      spacing: A,
      mode: s
    });
    return K(() => {
      w && w.width && I(w.width + 18 + 10);
    }, [w]), /* @__PURE__ */ S("div", { className: y.wrapper, children: [
      /* @__PURE__ */ d(
        "label",
        {
          htmlFor: v,
          id: b,
          className: y.accessibleLabel,
          children: r
        }
      ),
      /* @__PURE__ */ d(
        "input",
        {
          ref: N,
          id: v,
          name: t,
          type: m,
          disabled: u,
          placeholder: o ? void 0 : " ",
          className: y.input,
          ...p && { "aria-describedby": `${v}-helper` },
          ...n && { "aria-invalid": "true" },
          ...x && !o && { style: { paddingRight: C } },
          ...T
        }
      ),
      !o && !g && /* @__PURE__ */ d(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: v,
          className: y.visibleLabel,
          children: r
        }
      ),
      p && /* @__PURE__ */ d(
        "div",
        {
          id: `${v}-helper`,
          className: y.helperText,
          children: p
        }
      ),
      x && /* @__PURE__ */ d(
        "div",
        {
          ref: E,
          className: y.rightElement,
          children: x
        }
      ),
      n && p && /* @__PURE__ */ d(j, { politeness: "polite", clearAnnouncementDelay: 500, children: R })
    ] });
  }
);
G.displayName = "TextInput";
function fe(e) {
  return H(() => e.every((t) => t == null) ? () => {
  } : (t) => {
    e.forEach((r) => {
      typeof r == "function" ? r(t) : r != null && (r.current = t);
    });
  }, e);
}
const he = 500, be = 5e3, ge = 2e4, ye = B.forwardRef(
  ({
    name: e,
    disabled: t,
    label: r,
    labelHidden: n,
    onMaskChange: o,
    onChange: c,
    onBlur: l,
    onFocus: s,
    onTextInputMaskBlur: i,
    rightElement: u,
    spacing: h,
    ...b
  }, g) => {
    const [m, p] = M(!0), [x, A] = M({
      message: null,
      politeness: null
    }), T = k(!0), N = k(), E = k(null), w = fe([g, E]), C = m ? "Show" : "Hide", I = () => {
      clearTimeout(N.current), T.current || (N.current = window.setTimeout(() => {
        T.current = !0, p(!0), A({
          announcementTimeout: be,
          politeness: "polite",
          message: `${r} hiding characters`
        }), o && o(!0);
      }, ge));
    }, v = (f) => {
      f.preventDefault();
      const _ = !T.current;
      T.current = _, I(), p(_), A({
        announcementTimeout: he,
        politeness: "assertive",
        message: _ ? "Characters hidden" : "Characters showing"
      }), o && o(_);
    }, R = (f) => {
      var _;
      const { relatedTarget: z } = f, U = (_ = E.current) == null ? void 0 : _.parentElement;
      U != null && U.contains(z) || i && i();
    }, y = (f) => {
      I(), l && l(f), R(f);
    }, P = (f) => {
      I(), s && s(f);
    }, q = (f) => {
      I(), c && c(f);
    };
    return $(() => () => {
      clearTimeout(N.current);
    }, []), /* @__PURE__ */ S(J, { children: [
      /* @__PURE__ */ d(
        G,
        {
          ref: w,
          name: e,
          label: r,
          labelHidden: n,
          type: m ? "password" : "text",
          disabled: t,
          spacing: h,
          onBlur: y,
          onFocus: P,
          onChange: q,
          rightElement: B.cloneElement(u, {
            ref: g,
            label: C,
            onClick: v,
            onBlur: R,
            disabled: t
          }),
          ...b
        }
      ),
      /* @__PURE__ */ d(
        j,
        {
          role: "status",
          politeness: x.politeness,
          clearAnnouncementDelay: x.announcementTimeout,
          children: x.message
        }
      )
    ] });
  }
);
ye.displayName = "TextInputMask";
/*!
  @versini/ui-textinput v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTINPUT__ || (window.__VERSINI_UI_TEXTINPUT__ = {
    version: "1.0.0",
    buildTime: "09/18/2024 11:18 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
/*!
  @versini/ui-toggle v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TOGGLE__ || (window.__VERSINI_UI_TOGGLE__ = {
    version: "1.0.0",
    buildTime: "09/18/2024 11:18 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const ke = "av-toggle", xe = (e) => {
  let t = "";
  if (typeof e == "number" || typeof e == "string")
    t = "m-" + e;
  else {
    const r = [];
    (e == null ? void 0 : e.t) !== void 0 && r.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && r.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && r.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && r.push(`ml-${e.l}`), t = r.join(" ");
  }
  return t;
}, ve = () => a("peer", "h-6", "w-11", "rounded-full"), _e = ({
  focusMode: e
}) => a(
  "peer-focus:outline",
  "peer-focus:outline-2",
  "peer-focus:outline-offset-2",
  {
    "peer-focus:outline-focus-dark": e === "dark",
    "peer-focus:outline-focus-light": e === "light",
    "peer-focus:outline-focus-light dark:peer-focus:outline-focus-dark": e === "alt-system",
    "peer-focus:outline-focus-dark dark:peer-focus:outline-focus-light": e === "system"
  }
), Te = () => a(
  "peer-checked:after:translate-x-full",
  // background color when checked
  "peer-checked:bg-violet-500",
  // knob circle and border color when checked
  "peer-checked:after:bg-white",
  "peer-checked:after:border-white"
), we = () => a(
  "after:left-[2px]",
  "after:top-[2px]",
  "after:border",
  "after:border-surface-light dark:after:border-surface-medium",
  "after:bg-surface-light dark:after:bg-surface-medium",
  "after:absolute",
  "after:h-5",
  "after:w-5",
  "after:rounded-full",
  "after:transition-all",
  "after:content-['']"
), Ie = ({
  mode: e,
  noBorder: t
}) => a({
  border: !t,
  "border-border-dark bg-surface-medium": e === "light",
  "border-border-light bg-surface-darker": e === "dark",
  "border-border-light bg-surface-darker dark:border-border-dark dark:bg-surface-medium": e === "alt-system",
  "border-border-dark bg-surface-medium dark:border-border-light dark:bg-surface-darker": e === "system"
}), Ne = ({
  mode: e,
  labelHidden: t
}) => t ? "sr-only" : a("ml-2 text-sm", {
  "text-copy-dark": e === "light",
  "text-copy-lighter": e === "dark",
  "text-copy-lighter dark:text-copy-dark": e === "alt-system",
  "text-copy-dark dark:text-copy-lighter": e === "system"
}), Ae = ({ spacing: e }) => a(
  ke,
  "relative flex cursor-pointer items-center",
  xe(e)
), Ee = ({
  mode: e,
  focusMode: t,
  labelHidden: r,
  spacing: n,
  noBorder: o
}) => ({
  toggle: a(
    ve(),
    Ie({ mode: e, noBorder: o }),
    _e({ focusMode: t }),
    we(),
    Te()
  ),
  label: Ne({ mode: e, labelHidden: r }),
  input: "peer sr-only",
  wrapper: Ae({ spacing: n })
}), Ce = ({
  checked: e = !1,
  onChange: t,
  label: r,
  labelHidden: n = !1,
  name: o,
  mode: c = "system",
  focusMode: l = "system",
  spacing: s,
  noBorder: i = !1
}) => {
  const u = Ee({
    mode: c,
    focusMode: l,
    labelHidden: n,
    spacing: s,
    noBorder: i
  }), h = (b) => {
    t == null || t(b.target.checked);
  };
  return /* @__PURE__ */ S("label", { className: u.wrapper, children: [
    /* @__PURE__ */ d(
      "input",
      {
        name: o,
        checked: e,
        type: "checkbox",
        className: u.input,
        onChange: h
      }
    ),
    /* @__PURE__ */ d("div", { className: u.toggle }),
    /* @__PURE__ */ d("span", { className: u.label, children: r })
  ] });
};
export {
  Se as TextArea,
  G as TextInput,
  ye as TextInputMask,
  Ce as Toggle
};
